A Walk Through the Forest HDU - 1142 (最短路径+记忆化搜索)

Problem Description


Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer, his office is on one side of a forest, and his house is on the other. A nice walk through the forest, seeing the birds and chipmunks is quite enjoyable. 
The forest is beautiful, and Jimmy wants to take a different route everyday. He also wants to get home before dark, so he always takes a path to make progress towards his house. He considers taking a path from A to B to be progress if there exists a route from B to his home that is shorter than any possible route from A. Calculate how many different routes through the forest Jimmy might take. 

Input


Input contains several test cases followed by a line containing 0. Jimmy has numbered each intersection or joining of paths starting with 1. His office is numbered 1, and his house is numbered 2. The first line of each test case gives the number of intersections N, 1 < N ≤ 1000, and the number of paths M. The following M lines each contain a pair of intersections a b and an integer distance 1 ≤ d ≤ 1000000 indicating a path of length d between intersection a and a different intersection b. Jimmy may walk a path any direction he chooses. There is at most one path between any pair of intersections. 

Output


For each test case, output a single integer indicating the number of different routes through the forest. You may assume that this number does not exceed 2147483647

Sample Input


5 6

1 3 2

1 4 2

3 4 3

1 5 12

4 2 34

5 2 24

7 8

1 3 1

1 4 1

3 7 1

7 4 1

7 5 1

6 7 1

5 2 1

6 2 1

0

Sample Output


2

4

第一次见这样的题吧,最短路和dp

题意与思路:

一个人办公室在点1,家在点2,他要从办公室回家,他从点A到点B当且仅当从B到家的距离必任意一点从A到家的都小,求他回家路线的方案数
先用最短路预处理出到家的最短路,这里用Dijkstra算法,然后就是从办公室开始记忆化搜索

代码如下:

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
int const INF = 0x3fffffff;
int const MAX = 1005;
int dis[MAX], dp[MAX];
int map[MAX][MAX];
bool vis[MAX];
int n, m;
 
void Dijkstra(int v0)    //求最短路函数
{
    memset(vis, false, sizeof(vis));
    for(int i = 1; i <= n; i++)
        dis[i] = INF;
    for(int i = 1; i <= n; i++)
        dis[i] = map[v0][i];
    vis[v0] = true;
    dis[v0] = 0;
    for(int i = 1; i < n; i++)
    {
        int u = 0, mi = INF;
        for(int j = 1; j <= n; j++)
        {
            if(!vis[j] && dis[j] < mi)
            {
                mi = dis[j];
                u = j;
            }
        }
        vis[u] = true;
        for(int k = 1; k <= n; k++)
            if(!vis[k])
                dis[k] = min(dis[k], dis[u] + map[u][k]);
    }
}
 
int DFS(int x)            //dp函数
{
    if(dp[x])
        return dp[x];
    if(x == 2)
        return 1;
    int tmp = 0;
    for(int i = 1; i <= n; i++)
        if(dis[x] > dis[i] && map[x][i] != INF) //从题意知只要小一点就可以选择,所以继续dp
            tmp += DFS(i);
    return dp[x] = tmp;
}
 
int main()
{
    while(scanf("%d", &n) != EOF && n)
    {
        scanf("%d", &m);
        for(int i = 1; i <= n; i++)
            for(int j = 1; j <= n; j++)
                map[i][j] = INF;
        for(int i = 0; i < m; i++)
        {
            int u, v, w;
            scanf("%d %d %d", &u, &v, &w);
            map[u][v] = map[v][u] = w;
        }
        Dijkstra(2);//最短路模板调用
        memset(dp, 0, sizeof(dp));
        printf("%d\n", DFS(1));
    }
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值